#!/usr/local/bin/perl -w
#
#  
#     E2E monitoring configuration  webinterface
#     first virtual page is to see global links and add/remove/update them,
#     second virtual page is to add/remove/update nodes/link_type of the particular globallink
#     third virtual page is to configure SNMP parameters for monitoring of the paricular node/link
#     every page is Ajaxed, means its interactively updates webpage while you are entering and its not a multi-page 
#     use "Save" button to save new config in file ( it will effectively update every XML config and perl monitoring module )
#    author Maxim Grigoriev
#    2007
 
use strict;
use lib  ('/home/netadmin/LHCOPN/G2_E2E/scripts');
use CGI qw/:standard/;
use CGI::Carp qw(fatalsToBrowser); 
use Data::Dumper;
use CGI::Session;
use CGI::Ajax;
use HTML::Template; 
use IO::File;
use Storable qw(lock_retrieve lock_store);
#
#    configuration parameters are in the next packages
#
use E2EConfig qw(:MPConfig  $debug);
use XMLUtils qw(:XMLConfig);
use SNMPmonConfig qw(:Monitor);
use WEBConfig qw(:AdminWEBConfig $web_server);
#
#
#
$debug = 1; 
$ENV{PATH} = '/usr/bin:/usr/local/bin:/bin';
my $this_script = "$admin_server/secure-cgi/configure.pl";

#
#   although this is  the CGI script, but there is no HTML here
#   all html layout is defined by templates,   style defined by CSS
#   and interactive dynamic features exposed by javascript/Ajax
#   
my $cgi =   CGI->new();
my %links = $SNMP_CONFIG_OBJ->getall; 
my $SESSION = new CGI::Session("driver:File;serializer:Storable",  $cgi, {Directory => '/tmp'}); ## to keep our session
my $COOKIE =   $cgi->cookie( 'CGISESSID' )?$cgi->cookie( 'CGISESSID' ):$cgi->cookie( 'CGISESSID' => $SESSION->id);    ########   get cookie
#### to make it interactive ( registering perl calls as javascript functions)
##                           
my $ajax = CGI::Ajax->new( 'updateLinkGraph' => \&updateLinkGraph ,'configureLink' => \&configureLink,
                             'configureNode' => \&configureNode,'updateGlobal' => \&updateGlobal, 'updateNode' => \&updateNode,
			     'saveConfigs' => \&saveConfigs , "resetit" => \&resetit ); 
			     
#### These our global vars, there is no way to escape them since CGI::Ajax doesnt support structured data ( JSON ?)
#
my ($config,$nodes, $links_d, $extnodes) = ($SESSION->param( "LINKS" ), $SESSION->param( "NODES"), $SESSION->param( "SNMPL"), $SESSION->param( "EXTNODES")  );
###check if we saved previous session
unless( $config &&  $nodes) {
      carp(" .........Session expired...............  $COOKIE"  ) if $debug;
      $SESSION->delete();
      $SESSION = new CGI::Session("driver:File;serializer:Storable", undef , {Directory => '/tmp'});
      $COOKIE = $cgi->cookie(  'CGISESSID' => $SESSION->id);  
     ($config,$nodes, $extnodes ) = fillConfig(); 
     $links_d =  \%links ;
     storeSESSION($SESSION,   $links_d, $config, $nodes, $extnodes); 
}   
my $TEMPLATE_HEADER  = HTML::Template->new(filename => $what_template{header});
$TEMPLATE_HEADER->param( 'Title' => "$MYDOMAIN E2E Configuration Manager"); 
my $TEMPLATE_FOOTER  = HTML::Template->new(filename => $what_template{footer});
######## global view
my $myhtml = $TEMPLATE_HEADER->output() .   displayGlobal( $config , $nodes, $extnodes) . $TEMPLATE_FOOTER->output() ;  ##### get html
##$ajax->DEBUG($debug);
##$ajax->JSDEBUG($debug);
print $ajax->build_html( $cgi,  $myhtml, {'-Expires'=>'1d',   '-cookie' =>  $COOKIE   });
#
#---------------------------------------------------------------------------
#
############################################################################################ 
# 
#    store current session params
#
sub storeSESSION {
  my ($sess, $links_d, $config, $nodes,  $extnodes  ) = @_;
   $sess->param("SNMPL", $links_d );
   $sess->param("LINKS", $config );
   $sess->param("NODES", $nodes );
   $sess->param("EXTNODES", $extnodes );
} 
#  
#
#   update XML files ( Template for MP and config for vlanmon.pl and restart MP daemon)
#    
sub saveConfigs {
      my($input) = shift;
      return  displayGlobal($config, $nodes, $extnodes),"Wrong Request" unless $input && $input =~ /^Save\ (MP response XML Template|SNMP Config|All|SQL MA Config)$/;
      
      my $what = $1;
      if($what eq 'All' || $what eq  'XML Template') {
              storeTemplate($SESSION->id, $nodes, $extnodes, $config);
	     
	    }
     if($what eq 'All' || $what eq  'SNMP Config') {
              storeSNMP($SESSION->id, $links_d); 
	      
     } 
     
     if($what eq 'All' || $what eq  'SQL MA Config') {
              storeMA($SESSION->id, $nodes, $extnodes, $config ); 
	      
     }   
     ### manage_proc('ServerDaemon', 1);
     ###  sleep  3;
     ###   eval {
    ###       system($server_MP) 
     ###   };  
      ###  if($@) { 
     ###       return  ("!!! Failed to start MP Daemon  " . $@);
     ###   } elsif( !manage_proc('ServerDaemon', undef)) {
     ###       return  ("!!! Daemon seems to be started but there is no PID "); 
     ###   } else {
    return  displayGlobal($config, $nodes, $extnodes),displayResponse(" XML Template file was Saved and E2E MP was restarted")," <p> ";
        
}
 #  
#
#   reset  web interface
#    
sub resetit {
      my($input) = shift;
      return  displayGlobal($config, $nodes, $extnodes),"Wrong Request" unless $input && $input  eq 'Reset';
       
      ($config,$nodes, $extnodes) = fillConfig(); 
      $links_d =  \%links ;
      storeSESSION($SESSION, $links_d, $config, $nodes, $extnodes); 
	  
     return  displayGlobal($config, $nodes, $extnodes),displayResponse(" E2E configuration was reset ")," <p> " ;
        
}
#
#
#   print global view
#
#   arguments:  
#              $xmlconfig - ref ot hash with links to be monitored from XML template file
#              $nodes - ref to hash with nodes to be monitoried from XML template file
#              $extnodes - ref to hash with external nodes to be monitoried from XML template file
#            
#   return:  $html - HTML string
#
sub displayGlobal {
 my(  $xmlconfig, $nodes, $extnodes ) = @_;
    my %nodes = ();
   
    my $TEMPLATEg  = HTML::Template->new(filename =>  $what_template{'GlobalLinks'}) ;
    my @table2display = (); 
    my %link_names =();
  #####  map {$_->[0]} sort {$a->[1] cmp $b->[1] }  map {[$_, $xmlconfig->{$_ }{globalname}]} keys %{$xmlconfig}) 
   foreach my $datum ( keys %{$xmlconfig}) { 
     my $lname =  $xmlconfig->{$datum}{globalname} ;
     if($lname) { 
        unless($link_names{$lname}) {
          createGraph($xmlconfig, $lname );
        } 
        push  @{$link_names{$lname}}, {"link_name" =>  $xmlconfig->{$datum}{globalname},"unique_id" => time(), "datum" => $datum, nodes => (join "-", keys %{$xmlconfig->{$datum}{link}})};
     }
   }     
   
   foreach my $link  (sort keys %link_names ) {
      
       push  @table2display, {"link_name" => $link, mds => \@{$link_names{$link}}};
   
   } 
  ### carp(" ------------------- Links: " . Dumper  \@table2display);      
   $TEMPLATEg->param("Links" => \@table2display );
   @table2display = (); 
  
  foreach my $datum (keys %{$nodes}) {   
     push @table2display, {"node_id" => $nodes->{$datum}{node_id}  , "datum" => $datum};
  }     
   $TEMPLATEg->param( mydomain => $MYDOMAIN);     
  $TEMPLATEg->param("Nodes" => \@table2display );
  @table2display = ();   
  foreach my $nodeid(keys %{$extnodes}) {   
     push @table2display, {domain => ($nodeid =~ /^(\w+)\-/)[0], "node_id" =>$nodeid };
   } 
   $TEMPLATEg->param("ExtNodes" => \@table2display );
  
  return $TEMPLATEg->output();
}
##   arguments:  
#              $xmlconfig - ref ot hash with links to be monitored from XML template file
#              $nodes - ref to hash with nodes to be monitoried from XML template file
#              $extnodes - ref to hash with external nodes to be monitoried from XML template file
#              $links - shadow of the global %links hash with current SNMP parameters
#    
#   
#
sub displayLink {
   my  ($xmlconfig,   $nodes, $extnodes, $links_d ,$datum ) = @_;  
   my $g_viz =   GraphViz->new(directed=> '0',  epsilon => 0.001, fontname => 'Arial',ratio => 'compress', 
                      layout => 'dot', overlap => 'false' );     
   my %edges = ();
   my $TEMPLATEl  = HTML::Template->new(filename =>  $what_template{'Link'});
   my %link_colors = (DOMAIN_LINK => 'orange', ID_LINKPARTIALINFO => 'green');  
   my %node_color  = (EndPoint => "red", DemarcPoint => "blue");
   my $gmap_png = "$admin_location/graphs/domains_map$datum.png";
   my $gmap_map=  "$admin_location/graphs/domains_map$datum.map";

   my @nodes_display =();
   my @ifids_display =();
    
   my $link_name =  $xmlconfig->{$datum}{globalname};
   $TEMPLATEl->param("link_name" => $link_name); 
    
  ### next unless $link_name eq $link_id;
  my $lnk_t = $xmlconfig->{$datum}{link_type};
  $TEMPLATEl->param("link_type" =>  $lnk_t ); 
  $TEMPLATEl->param("datum" =>  $datum); 
  $TEMPLATEl->param("select_ltype1" =>  ' selected="yes">', "select_ltype2" =>  '>') if $lnk_t =~ /^ID\_LINKPARTIALINFO/i; 
  $TEMPLATEl->param("select_ltype2" =>  ' selected="yes">', "select_ltype1" =>  '>') if $lnk_t =~ /^DOMAIN\_LINK/i; 
  $TEMPLATEl->param("unique_id" => time()); 
   foreach my $ifid (keys %{$links_d}) {
          my $rtr =  $links_d->{$ifid}->{rtr};
	   foreach my $ifport (keys %{$links_d->{$ifid}}) {
              if($ifport ne   'rtr' && $links_d->{$ifid}->{$ifport}->{'datum'}->{$datum}) {
	           push @ifids_display,  {datum => $datum, rtr => $rtr, ifid => $ifid, iport => $ifport, 
		                          vlan => $links_d->{$ifid}->{$ifport}->{vlan}, bgp => $links_d->{$ifid}->{$ifport}->{bgp}  };
	      }  
	 }	
       
   }    
   my $edge =   '';
   my $node0 =  '';
   foreach my $node (keys %{$xmlconfig->{$datum}{link}} ) {
   
	     (my $domain) = $node =~ /^([A-Z]+)\-/; 
	     my $node_type =  $xmlconfig->{$datum}{link}->{$node};
	     my @allnodes = ();
             foreach my $nodeid (keys %{$nodes}) {
	       push @allnodes, {node => $nodes->{$nodeid}{node_id} ,  selected_node => ( $nodes->{$nodeid}{$node}?' selected="yes">':'>')};
	     }
	     foreach my $nodeid (keys %{$extnodes}) {
	       push @allnodes, {node => $nodeid,   selected_node => ($extnodes->{$node}?' selected="yes">':'>')};
	     }
	     my %anon_hash = ( datum => $datum, node => $node, node_type => $xmlconfig->{$datum}{link}->{$node},  allnodes => \@allnodes);
	      ($node_type eq 'EndPoint')?eval{$anon_hash{select_EndPoint} = ' selected="yes">';$anon_hash{select_DemarcPoint} = '>'}:
	      eval{$anon_hash{select_EndPoint} = '>';$anon_hash{select_DemarcPoint} = ' selected="yes">'};
             push @nodes_display,  \%anon_hash;
	     $g_viz->add_node($node , label => $node  , color =>  $node_color{$xmlconfig->{$datum}{link}->{$node}},   
	                      URL => "${web_server}/G2_E2E_view_e2elink_$link_name.html",
			cluster =>  {name => "  $domain ", fontsize => '14', fontname => 'Arial'}, 
			shape => 'oval', fontsize=>'12', fontname => 'Arial' ); 
		     ##   warn ("Node changed ::: " . $nodes[$i]);
	  $edge .= $edge?"-$node":$node;
	  $node0?$g_viz->add_edge(  $node0   =>   $node, label =>  "$lnk_t" ,   
		fontcolor =>   'blue' , color =>  $link_colors{ uc($lnk_t)},
		fontsize => '10', fontname => 'Arial'): $node0 =   $node;   
   }
   	 
  $TEMPLATEl->param("Nodes" => \@nodes_display);  
  $TEMPLATEl->param("Ifids" => \@ifids_display);
  $g_viz->as_png($gmap_png);
  $g_viz->as_imap($gmap_map);	  
  return $TEMPLATEl->output();     
}
  
#
#    
#   show $datum Node config form
#
sub displayNode {
   my  ($nodes,  $datum ) = @_;
  
   my $TEMPLATEn  = HTML::Template->new(filename =>  $what_template{'Node'} );
   my $TEMPLATEgm  = HTML::Template->new(filename =>  $what_template{'gmap'} );  
    
     $TEMPLATEn->param(node_id => $nodes->{$datum}{node_id});
   my @params = ();
   my $nodeinfo =  "<u>Node:</u>" . $nodes->{$datum}{node_id} . "<br>" ;
   
   foreach my $info (qw/country city latitude institution longitude/) {
	 
	if($info =~ /latitude|longitude/) {
	    my $newcoor = lnglat2degree($nodes->{$datum}{$info}); 
	    $TEMPLATEgm->param($info =>  $newcoor);
	    push @params,  {datum => $datum , what => $info, valuen => $newcoor};
	} else {
	  push @params,  {datum => $datum , what => $info,  valuen => $nodes->{$datum}{$info}}; 
	  
	  $nodeinfo .= " $info:" .  $nodes->{$datum}{$info} . "<br>";
	}
   }
    
    $TEMPLATEgm->param(gkey =>  $google_key );
    $TEMPLATEgm->param(nodeinfo => $nodeinfo);   
    $TEMPLATEgm->param(Title=> "This Node on the map");
    my $outf = "$admin_location/graphs/gmap_" . $nodes->{$datum}{node_id} . ".htm";
    open OUTF, ">$outf" or croak(" Failed to open file: $outf");
    print OUTF $TEMPLATEgm->output(); 
    close OUTF;
    $TEMPLATEn->param(unique => time());  
    $TEMPLATEn->param(nodeparams =>   \@params ); 
 
  return $TEMPLATEn->output();   
  
}
#
#  configre link callback id=ConfigureLink<TMPL_VAR NAME=datum>, $datum, $linkname,  
#
sub configureLink {
  my ($id,$datum, $input_button  ) = @_;
  if($id =~ /^ConfigureLink/ && $datum && $config->{$datum} &&  $input_button eq 'Configure Sub-Link') { 
     return displayLink($config, $nodes, $extnodes,  $links_d, $datum );
  } else {
     return displayResponse(" !!!BAD Configure Sub-Link CALL=$id or metadata=$datum or button=$input_button !!! ");
  }
}

#
#  configre link callback id=ConfigureLink<TMPL_VAR NAME=datum>, $datum, $linkname,  
#
sub configureNode {
  my ($id,$datum, $input_button  ) = @_;
  if($id =~ /^ConfigureNode/ && $datum && $nodes->{$datum} &&  $input_button eq 'Configure Node') { 
     return displayNode($nodes,  $datum );
  } else {
     return displayResponse(" !!!BAD Configure Node CALL=$id or metadata=$datum  or button=$input_button !!! ");
  }
}

#
#   callback for dynamic update on "add" "remove" "update" Ajax calls
#   Supported $id values:  remove_node_xxx , add_nod_xxx , update_node_typexxx
#                         remove_link_xxx , update_link_xxx , add_link_xxx
#   where xxx is unique id of the object to be removed/added/updated and   follows the format:
#     $datum|$link_type  or    $datum|$node|$node
#    logical name of link will be the datum and any skipped parameter will be automatically generated
#   $input is "removeit" or new/added value of the unique obejct id ( mdXX for datum, "FERMI-XXXX" for node id, "CERN-FERMI-LHCOPN-001" for globalname )           
# 
sub updateLinkGraph {
my ($action, $datum, $param1,  $param2, $param3, $param4, $param5) = @_;
   my $response = "OK";
   if($datum && $config->{$datum}) {
     if($param1 &&  ($action =~ /^(update\_linktype|update\_node)/ || ( $action =~ /^(update\_type)/  && $param2 =~ /^(DemarcPoint|EndPoint)/ )) ) {
         if($action eq 'update_linktype' && $param1 =~ /^(DOMAIN_LINK|ID_LinkPartialInfo)$/i) {
	      $config->{$datum}{link_type} = $param1;
	 
	 } elsif( $action  =~  /^update\_type[\w\-\.]+/ && $param1 =~ /^(\w+\-\w+)$/) { 
	        my $oldnode = $1;
	        my ($newtype) =  $param2 =~ /^(DemarcPoint|EndPoint)/ ;
	        $config->{$datum}{link}->{$oldnode} = $newtype;
		 
	} elsif( $param1 =~ /^\w+\-\w+$/ &&  $action =~ /^update\_node([\w\-\.]+)/) {
	        my $oldnode = $1;
	         
		my %old_link =%{$config->{$datum}{link}};
	        my $oldtype = $old_link{$oldnode};
	        undef $config->{$datum}{link};
	        delete $old_link{$oldnode};
	        $old_link{$param1} = $oldtype;
	        $config->{$datum}{link} = \%old_link;
		
	 } else {
	     $response = "!!!BAD  LINK CONFIGURE  PARAM:$action  $datum  $param1  $param2 !!! ";
	 } 
        
     } elsif($action eq 'add_mon' &&
             ($param1 =~ /^[\w\-\.]+$/ && $param2 =~ /^[\d.]+$/ && $param3 =~ /^\d+$/ &&
	     (!$param4 || $param4 =~ /^[\d\.]+$/) &&  (!$param5 || $param5 =~ /^\d+$/)) ) {
	        $links_d->{$param2}->{$param3}->{'datum'}{$datum} = $config->{$datum}{globalname};
                $links_d->{$param2}->{rtr} = $param1;
		my $status = 1;
		if($param5)  {
		  $links_d->{$param2}->{$param3}->{vlan} = $param5;
		  $status++;
		 }
		if($param4)  { 
		  $links_d->{$param2}->{$param3}->{bgp} = $param4;
		  $status++;
		 }
		 $links_d->{$param2}->{$param3}->{status} = $status;
		### carp(" ---------- Added Mon: ifid=$param2 rtr=$param1 iport=$param3 bgp= $param4 vlan= $param5 status=$status ");
	    
     } elsif((!$param1 || $param1 =~ /^[\w\-\.]+$/) && $action =~ /^update_rtr([\d\.]+)\:(\d+)$/ ) {
            if($param1) {
               $links_d->{$1}->{rtr} = $param1; 
	    } else {
	         delete $links_d->{$1};
	    }   
     }  elsif((!$param1 || $param1 =~ /^[\d\.]+$/)  &&  $action =~  /^update_ifid([\d\.]+)\:(\d+)$/ )  {
              if($param1) {
	         $links_d->{$param1} = $links_d->{$1};     
	      } 
	      delete $links_d->{$1};
     }  elsif  ((!$param1 || $param1 =~ /^\d+$/)   &&  $action =~  /^update_iport([\d\.]+)\:(\d+)$/) { 
              if($param1) {
	         $links_d->{$1}->{$param1} =   $links_d->{$1}->{$2};
	       }
	       delete   $links_d->{$1}->{$2} ;
     }  elsif  ((!$param1 || $param1 =~ /^[\d\.]+$/) && $action =~  /^update_bgp([\d\.]+)\:(\d+)$/  )  {
               if($param1) {
	            $links_d->{$1}->{$2}->{bgp} =  $param1;
	       } else {
	            $links_d->{$1}->{$2}->{status}--;
	       }
     }  elsif  ((!$param1 || $param1 =~ /^(\d+)$/)     && $action =~   /^update_vlan([\d\.]+)\:(\d+)$/) {
           if($param1) {
	           $links_d->{$1}->{$2}->{vlan} =  $param1; 
	       } else {
	            $links_d->{$1}->{$2}->{status}--;
	       }
     }  else {
      
      $response =  " !!!BAD LINK CONFIG CALL:$action  meta=$datum  p1=$param1  p2=$param2 p3=$param3 p4=$param4 p5=$param5!!! ";
     }	  
   }  else {
      
      $response =  " !!!BAD LINK CONFIG CALL:$action  meta=$datum  p1=$param1  p2=$param2 p3=$param3 p4=$param4 p5=$param5!!! ";
  }
  if($response eq "OK") { 
      storeSESSION($SESSION, $links_d, $config, $nodes, $extnodes); 
  }
  return  displayLink($config, $nodes, $extnodes,  $links_d, $datum), displayResponse($response);
}
 
#
#
#   update Domain Node info
#
sub updateNode {
my ($action, $datum, $param1 ) = @_; 
   my $response = "OK";
    my %validation_regs =(country => '^\w{2}$', city => '^\w+$', latitude => '^(\-)?\d+(\.\d+)?$', institution => '^[\w\s\.]+$',longitude => '^(\-)?\d+(\.\d+)?$');
   if($datum && $nodes->{$datum} &&   $param1 && ( $action =~ /^update\_(country|city|latitude|institution|longitude)/)) {
         my $item = $1;
	 if($param1 =~ /$validation_regs{$item}/o) {
	    if($item =~ /latitude|longitude/) {
	      $nodes->{$datum}{$item} = degree2lnglat($param1, $item); 
	    } else {
	      $nodes->{$datum}{$item} = $param1; 
	    }
	 } else {
	   $response =     " !!!BAD NODE PARAM:$action  $datum  $param1    !!! ";
	 } 
      
   } else {
     $response =   " !!!BAD NODE CONFIG CALL:$action  $datum  $param1   !!! ";
  }
  if($response eq "OK") {
   $SESSION->param("NODES", $nodes);
  }
  return  displayNode($nodes,  $datum),displayResponse($response);
}
#
#   callback for dynamic update on "add" "remove" "update" Ajax calls
#   Supported $id values: remove_global  , add_global  , update_global  
#                         remove_datum , add_datum , update_datum
#                      
#     
#    logical name of link will be the datum and any skipped parameter will be automatically generated
#   $input is "removeit" or new/added value of the unique obejct id ( mdXX for datum, "FERMI-XXXX" for node id, "CERN-FERMI-LHCOPN-001" for globalname )           
# 
sub updateGlobal {
my ($action,   $datum, $new_name ) = @_; 
   my $response = "OK";
   my ($act, $what, $what_id)  =  $action =~ /^([a-z]+)\_(link|node(?:name)?)\_?([\w\-]+)?/;
   if($datum) {
     if( $datum =~ /^[\w\-]+$/ && $act eq 'add' &&  $what =~ /^(link|node)$/) {         
            my $nindex = addNew($datum, $what);
	    if($nindex  >= $MAXNODES) {
               $response =   "!!!Number of Nodes out of bound: Increase MAXNODES parameter !!!";
            } else {
	       $datum = "md$nindex";
	    }

     } elsif( $act eq 'update' && $new_name && $new_name =~ /^[\w\-]+$/) {  
              if($what =~ /node/ &&  $nodes->{$datum}) {
	         my $oldnode =   $nodes->{$datum}{node_id};
		 $nodes->{$datum}{$new_name} =   $nodes->{$datum}{$oldnode};
		 $nodes->{$datum}{node_id} = $new_name;
		 delete $nodes->{$datum}{$oldnode};
		 ## fix Node name in the global link 
	         if( my $result = renameNode($new_name, $oldnode)  ) {
		    $response .=   "  -- Node name was updated in the next Links: $result ";
		 }    else {
		    $response =   " !!!NODE NAME UPDATE FAILED: Old Node name= $oldnode was not found in any Global Link !!!";
		 }
	      } elsif($what eq 'link' &&  $config->{$datum} ) {
	            my $oldname = $config->{$datum}{globalname};
                    $config->{$datum}{globalname} = $new_name; 
		    $config->{$datum}{$new_name} = $config->{$datum}{$oldname};
		    delete  $config->{$datum}{$oldname};
	      } else {
	           $response =   " !!!BAD UPDATE PARAM:$action  metadataID=$datum  UpdatedParam=$new_name  !!!";
	      }
	       
      } elsif($act eq 'remove' && $new_name && $new_name eq 'Remove') { 
	     if($what =~ /node/ &&  $nodes->{$datum} ) {
	           delete $nodes->{$datum};
	     } elsif( $what eq 'link' &&  $config->{$datum} ) {
	          delete  $config->{$datum};
		  &unmonDatum($datum);
	     }  else {
	          $response ="!!!BAD REMOVE PARAM:$action   metadataID=$datum  RemoveParam=$new_name  !!!";
	     }
      } else {
	    $response =   "!!!BAD CALL PARAM:$action metadataID=$datum  callParam=$new_name    !!!";
      }    
       
   } else {
     $response = "!!! MISSED PARAM:$action  metadataID=$datum   callParam=$new_name  !!!";
  }
 if($response =~ /^OK/) { 
     storeSESSION($SESSION, $links_d, $config, $nodes, $extnodes); 
   
    if($act ne 'remove'  ) {
       if($what =~ /node/  ) {
          return  displayGlobal($config, $nodes, $extnodes),$response,displayNode($nodes, $datum);
       } else {
          return  displayGlobal($config, $nodes, $extnodes),$response,displayLink($config, $nodes, $extnodes, $links_d, $datum);
       } 
    }
 }
 return  displayGlobal($config, $nodes, $extnodes),displayResponse($response),'&nbsp;';
  
}
 
#
#    create new node or global link
#
sub addNew {
   my($datum, $what ) = @_;
   my $i  = 0;
   for( $i = 1;$i<$MAXNODES; $i++) {
          my $newid = "md$i";
         if(!$config->{$newid} && !$nodes->{$newid}) {
	   if($what eq 'link') { 
	     $config->{$newid}{$datum} = $newid;
	     $config->{$newid}{globalname} = $datum;
	     $config->{$newid}{subj_id} =  "sub$i";
	      
	     ###  lets assign some defaults
	 
	      $config->{$newid}{link_type} = "DOMAIN_Link";
	      $config->{$newid}{link} = {"$MYDOMAIN-NODE1" => 'EndPoint',"$MYDOMAIN-NODE2" => 'DemarcPoint' };
	           
	   } elsif ($what eq 'node') {
	       $nodes->{$newid}{node_id} = $datum;
	       $nodes->{$newid}{subj_id} = "sub-$datum";
	       $nodes->{$newid}{$datum} = $newid;
	       $nodes->{$newid}{'type'} = "TopologyPoint";    
          } 
	  last;
       }
  } 
  ### carp(" +++++++++++++ $what $datum added as md$i");
  return  "$i";
}
#
#    check existing link names
#
sub isLinkExist {
   my($linkname,  $config) = @_;
    
   foreach my $datum (keys %{$config}) {  
         if( $config->{$datum}{$linkname} ) {
	  return 'yes';
       }
  } 
  return undef;
}
#
#   rename Node in the Global Link
#
sub renameNode {
   my(  $newnode, $oldnode ) = @_;
   my $result = ''; 
   foreach my $datum (keys %{$config}) {  
       foreach my $node (keys %{$config->{$datum}{link}}) {
          if($node eq $oldnode) {
	      $config->{$datum}{link}->{$newnode} = $config->{$datum}{link}->{$node};
	      delete $config->{$datum}{link}->{$node}; 
	      $result .=  " $datum";
	  }
       }
  } 
  return $result;
}
#
#   remove monitoring info about particular datum
#
sub unmonDatum {
   my($datum) = @_;
  my $result = ''; 
  foreach my $ifid (keys %{$links_d}) {
   
     foreach my $ifport (keys %{$links_d->{$ifid}}) {
        next if $ifport eq 'rtr';  
         
        delete $links_d->{$ifid}->{$ifport}->{'datum'}{$datum}; 
	 
    }   
 }   
 
}
 
