package E2EConfig;
########################################
#
#  maxim@fnal.gov 2007, MG
#
#    
#   configurable parameters for E2E MP and MA
#
# 
 
use strict;
use warnings;
use POSIX qw(strftime);
use Carp;
use IO::File;
use Config::General;
BEGIN {
        use Exporter   ();
         
        our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
      
        # set the version for version checking
        $VERSION     = 1.00;
        # if using RCS/CVS, this may be preferred
        $VERSION = sprintf "%d.%03d", q$Revision: 1.1 $ =~ /(\d+)/g;

        @ISA         = qw(Exporter);
        @EXPORT      = qw( );
        %EXPORT_TAGS = (  
                          Utils => [qw!&dnsName &sectotime &manage_proc!] );     # eg: TAG => [ qw!name1 name2! ],
                        
        # your exported package globals go here,
        # as well as any optionally exported functions
        @EXPORT_OK   = qw($debug  %GENERAL_CONFIG   &dnsName &sectotime    &manage_proc  );                        
     };
     
our @EXPORT_OK;
our ( $debug,  %GENERAL_CONFIG  );
my $config_file = "/home/netadmin/LHCOPN/G2_E2E/etc/GeneralSystem.conf";
my $conf_obj =  new Config::General(-ConfigFile =>   $config_file, 
                                      -AutoTrue => '',
				      -InterPolateVars => '1',
                                      -StoreDelimiter => '=');
%GENERAL_CONFIG  = $conf_obj->getall;
croak("Problem with parsing config file: $config_file ") unless %GENERAL_CONFIG && $GENERAL_CONFIG{MYDOMAIN};

#
#    check daemon pid and kill it if asked and return one
#
#
sub manage_proc {
      my ($id, $killit) = @_;
      my $pid = `/bin/ps auxw | grep -v grep | grep $id`;
      if($pid) {
          chomp $pid;
         $pid =~ s/^\w+\s+(\d+)\s+.+$/$1/;
	 kill ('TERM', $pid) if $killit;
      }  
     return $pid;
}
# 
# Transform seconds into a readable format (NNNdNNhNNm).
#
sub sectotime {
   my($sec) = @_;
   my $texttime = "";
   if ($sec >= 86400) {
           $texttime = int($sec/86400) . "d";
           $sec -= int($sec/86400)*86400;
   };

   if ($sec >= 3600) {
           $texttime .= int($sec/3600) ."h";
           $sec -= int($sec/3600)*3600;
   } else {
           $texttime .= "0h";
   }

   $texttime .= int($sec/60) . "min";
   return ($texttime);
}
#
#  get DNS name 
#
 
sub dnsName {
   my ($ip ) = @_;
   if($GENERAL_CONFIG{nslookup} && -x $GENERAL_CONFIG{nslookup}) {
     my ($nslook) = `$GENERAL_CONFIG{nslookup}  $ip` =~ /name =\s+([\w\.\-]+)/m;
     if($nslook) {
        return  "\t Nodename:  $nslook ";
     } else {
        return "\t Nodename:  not in DNS "; 
     }
   } else {
        return "\t Unavailable  "; 
   }
}


1;
