package WEBConfig;
########################################
#
#  maxim@fnal.gov 2007, MG
#
#    
#   configurable parameters for Web layer of  E2E MP and MA 
#   webserver url, templates etc...
# 
 
use strict;
use warnings;
use POSIX qw(floor abs);
use GraphViz;
BEGIN {
        use Exporter   ();
         
        our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
      
        # set the version for version checking
        $VERSION     = 1.00;
        # if using RCS/CVS, this may be preferred
        $VERSION = sprintf "%d.%03d", q$Revision: 1.1 $ =~ /(\d+)/g;

        @ISA         = qw(Exporter);
        @EXPORT      = qw( );
        %EXPORT_TAGS = (
	      AdminWEBConfig => [qw!&displayResponse &degree2lnglat &lnglat2degree &createGraph !],
                   );     # eg: TAG => [ qw!name1 name2! ],
                        
        # your exported package globals go here,
        # as well as any optionally exported functions
        @EXPORT_OK   = qw(    &createGraph   &lnglat2degree     &degree2lnglat &displayResponse  );                        
     };
     
our @EXPORT_OK;
use E2EConfig    qw($debug  %GENERAL_CONFIG);
   
 
############################################################################
#
#
#   creates  PNG image with internal map of the particular global link
#
sub createGraph {
 my ($xmlconfig, $link_request) = @_;
   my $g_viz =   GraphViz->new(directed=> '0',  epsilon => 0.001, fontname => 'Arial',ratio => 'compress', 
                      layout => 'dot', overlap => 'false' );     
   my %edges = ();
  
   my %link_colors = (DOMAIN_LINK => 'orange', ID_LINKPARTIALINFO => 'green');  
   my %node_color  = (EndPoint => "red", DemarcPoint => "blue");
   my $gmap_png = "$GENERAL_CONFIG{admin_location}/graphs/domains_map$link_request.png";
   my $gmap_map=  "$GENERAL_CONFIG{admin_location}/graphs/domains_map$link_request.map";
  
   foreach my $datum (keys %{$xmlconfig}) { 
       my $link_name =  $xmlconfig->{$datum}{globalname};
       my  $link_type   =  $xmlconfig->{$datum}{link_type};
       next unless $link_name eq $link_request;
       my $edge =   '';
       my $node0 =  '';    
      foreach my $node (keys %{$xmlconfig->{$datum}{link}} ) {
   
	     (my $domain) = $node =~ /^([A-Z]+)\-/; 
	     my $node_type =  $xmlconfig->{$datum}{link}->{$node};
	     
	     $g_viz->add_node($node , label => $node  , color =>  $node_color{$node_type},  
	                URL => " $GENERAL_CONFIG{web_server}/G2_E2E_view_e2elink_$link_name.html",
			cluster =>  {name => "  $domain ", fontsize => '14', fontname => 'Arial'}, 
			shape => 'oval', fontsize=>'12', fontname => 'Arial' ); 
		     ##   warn ("Node changed ::: " . $nodes[$i]);
	  $edge .= $edge?"-$node":$node;
	  $node0?$g_viz->add_edge(  $node0   =>   $node, label =>  "$link_type" ,   
		fontcolor =>   'blue' , color =>  $link_colors{ uc($link_type)},
		fontsize => '10', fontname => 'Arial'): $node0 =   $node;   
     }
  }
  $g_viz->as_png($gmap_png);
  $g_viz->as_imap($gmap_map);	

} 
#
#  convert longitude/latitude from this format /^(\d+)x(\d+)\'([\d\.]+)\'\'(\w)/
#         into the +-(\d+)\.(\d+)
#
sub lnglat2degree {
 my ($value) = shift;
 my %signs = (W => '-1', S => '-1', N => '1', E => '1'); 
 my ($deg, $min, $sec, $sign) = $value =~ /^(\d+)x(\d+)\'([\d\.]+)\'\'(\w)/;
 return $signs{$sign}*($deg + $min/60. + $sec/3600.);
}
#
#  convert longitude/latitude from this +-(\d+)\.(\d+) format into the  /^(\d+)x(\d+)\'([\d\.]+)\'\'(\w)/
#  params:
#       $value - coordinate in degrees
#       $what    
#
sub degree2lnglat {
 my ($value, $what) = @_;
 my $sign = "''";
 if($what eq 'latitude') {
     $sign .= $value<0?'S':'N'; 
 } else {
    $sign .= $value<0?'W':'E';  
 }
 $value = abs($value);
 my $deg = POSIX::floor($value);
 my $min = POSIX::floor(($value - $deg)*60);
 my $sec = sprintf("%3.1f", (((($value - $deg) - $min/60)*3600)*100)/100);
 warn " +++++++++++++ input $value new coordinate: ${deg}x$min'$sec$sign\n";
 return  "${deg}x$min'$sec$sign" ;
}
#
#   customize your response Message here 
#   
#
sub displayResponse {
    my  $message  = shift;
    return "Last Action Status: " . $message;

}
1;
